diff --git a/bfd/po/Make-in b/bfd/po/Make-in
index 30bcd5576e9..af8f4fb5757 100644
--- a/bfd/po/Make-in
+++ b/bfd/po/Make-in
@@ -93,19 +93,21 @@ all-yes: $(CATALOGS) @MAINT@ $(PACKAGE).pot
 all-no:
 
 $(srcdir)/$(PACKAGE).pot: $(SRC-POTFILES) $(BLD-POTFILES)
-	$(XGETTEXT) --default-domain=$(PACKAGE) \
+	$(XGETTEXT) -o $(PACKAGE)-tmp.pot \
+	  --default-domain=$(PACKAGE) \
 	  --directory=$(top_srcdir) \
 	  --add-comments --keyword=_ --keyword=N_ \
 	  --msgid-bugs-address=https://sourceware.org/bugzilla/ \
 	  --files-from=$(srcdir)/SRC-POTFILES.in 
-	$(XGETTEXT) --default-domain=$(PACKAGE) \
+	$(XGETTEXT) -o $(PACKAGE)-tmp.pot \
+	  --default-domain=$(PACKAGE) \
 	  --directory=.. \
 	  --directory=. \
 	  --add-comments --keyword=_ --keyword=N_ \
 	  --join-existing \
 	  --msgid-bugs-address=https://sourceware.org/bugzilla/ \
 	  --files-from=$(srcdir)/BLD-POTFILES.in
-	sed -e '/^#:/s,$(top_srcdir)/,,g' < $(PACKAGE).po > $@-t
+	sed -e '/^#:/s,$(top_srcdir)/,,g' < $(PACKAGE)-tmp.pot > $@-t
 	mv -f $@-t $@
 
 $(srcdir)/cat-id-tbl.c: stamp-cat-id; @:
diff --git a/binutils/po/Make-in b/binutils/po/Make-in
index 167b04b7560..6ae60ac2bcd 100644
--- a/binutils/po/Make-in
+++ b/binutils/po/Make-in
@@ -87,12 +87,13 @@ all-yes: $(CATALOGS) @MAINT@ $(PACKAGE).pot
 all-no:
 
 $(srcdir)/$(PACKAGE).pot: $(POTFILES)
-	$(XGETTEXT) --default-domain=$(PACKAGE) --directory=$(top_srcdir) \
+	$(XGETTEXT) -o $(PACKAGE)-tmp.pot --directory=$(top_srcdir) \
+	  --default-domain=$(PACKAGE) \
 	  --add-comments --keyword=_ --keyword=N_ \
 	  --msgid-bugs-address=https://sourceware.org/bugzilla/ \
 	  --files-from=$(srcdir)/POTFILES.in
 	rm -f $(srcdir)/$(PACKAGE).pot
-	mv $(PACKAGE).po $(srcdir)/$(PACKAGE).pot
+	mv $(PACKAGE)-tmp.pot $(srcdir)/$(PACKAGE).pot
 
 $(srcdir)/cat-id-tbl.c: stamp-cat-id; @:
 $(srcdir)/stamp-cat-id: $(PACKAGE).pot
diff --git a/gas/po/Make-in b/gas/po/Make-in
index 167b04b7560..6ae60ac2bcd 100644
--- a/gas/po/Make-in
+++ b/gas/po/Make-in
@@ -87,12 +87,13 @@ all-yes: $(CATALOGS) @MAINT@ $(PACKAGE).pot
 all-no:
 
 $(srcdir)/$(PACKAGE).pot: $(POTFILES)
-	$(XGETTEXT) --default-domain=$(PACKAGE) --directory=$(top_srcdir) \
+	$(XGETTEXT) -o $(PACKAGE)-tmp.pot --directory=$(top_srcdir) \
+	  --default-domain=$(PACKAGE) \
 	  --add-comments --keyword=_ --keyword=N_ \
 	  --msgid-bugs-address=https://sourceware.org/bugzilla/ \
 	  --files-from=$(srcdir)/POTFILES.in
 	rm -f $(srcdir)/$(PACKAGE).pot
-	mv $(PACKAGE).po $(srcdir)/$(PACKAGE).pot
+	mv $(PACKAGE)-tmp.pot $(srcdir)/$(PACKAGE).pot
 
 $(srcdir)/cat-id-tbl.c: stamp-cat-id; @:
 $(srcdir)/stamp-cat-id: $(PACKAGE).pot
diff --git a/gold/po/Make-in b/gold/po/Make-in
index e8e881ba3e3..9fea006bf50 100644
--- a/gold/po/Make-in
+++ b/gold/po/Make-in
@@ -87,12 +87,13 @@ all-yes: $(CATALOGS) @MAINT@ $(PACKAGE).pot
 all-no:
 
 $(srcdir)/$(PACKAGE).pot: $(POTFILES)
-	$(XGETTEXT) --default-domain=$(PACKAGE) --directory=$(top_srcdir) \
+	$(XGETTEXT) -o $(PACKAGE)-tmp.pot --directory=$(top_srcdir) \
+	  --default-domain=$(PACKAGE) \
 	  --add-comments -C --keyword=_ --keyword=N_ \
 	  --msgid-bugs-address=https://sourceware.org/bugzilla/ \
 	  --files-from=$(srcdir)/POTFILES.in
 	rm -f $(srcdir)/$(PACKAGE).pot
-	mv $(PACKAGE).po $(srcdir)/$(PACKAGE).pot
+	mv $(PACKAGE)-tmp.pot $(srcdir)/$(PACKAGE).pot
 
 $(srcdir)/cat-id-tbl.c: stamp-cat-id; @:
 $(srcdir)/stamp-cat-id: $(PACKAGE).pot
diff --git a/gprof/po/Make-in b/gprof/po/Make-in
index ba6f3923308..4b5c174f1e0 100644
--- a/gprof/po/Make-in
+++ b/gprof/po/Make-in
@@ -87,12 +87,13 @@ all-yes: $(CATALOGS) @MAINT@ $(PACKAGE).pot
 all-no:
 
 $(srcdir)/$(PACKAGE).pot: $(POTFILES)
-	$(XGETTEXT) --default-domain=$(PACKAGE) --directory=$(top_srcdir) \
+	$(XGETTEXT) -o $(PACKAGE)-tmp.pot --directory=$(top_srcdir) \
+	  --default-domain=$(PACKAGE) \
 	  --add-comments --keyword=_ --keyword=N_ \
 	  --msgid-bugs-address=https://sourceware.org/bugzilla/ \
 	  --files-from=$(srcdir)/POTFILES.in
 	rm -f $(srcdir)/$(PACKAGE).pot
-	mv $(PACKAGE).po $(srcdir)/$(PACKAGE).pot
+	mv $(PACKAGE)-tmp.pot $(srcdir)/$(PACKAGE).pot
 
 $(srcdir)/cat-id-tbl.c: stamp-cat-id; @:
 $(srcdir)/stamp-cat-id: $(PACKAGE).pot
diff --git a/ld/po/Make-in b/ld/po/Make-in
index 26e318570fb..c6a301def68 100644
--- a/ld/po/Make-in
+++ b/ld/po/Make-in
@@ -89,17 +89,19 @@ all-yes: $(CATALOGS) @MAINT@ $(PACKAGE).pot
 all-no:
 
 $(srcdir)/$(PACKAGE).pot: $(SRC-POTFILES) $(BLD-POTFILES)
-	$(XGETTEXT) --default-domain=$(PACKAGE) --directory=$(top_srcdir) \
+	$(XGETTEXT) -o $(PACKAGE)-tmp.pot --directory=$(top_srcdir) \
+	  --default-domain=$(PACKAGE) \
 	  --add-comments --keyword=_ --keyword=N_ \
 	  --msgid-bugs-address=https://sourceware.org/bugzilla/ \
 	  --files-from=$(srcdir)/SRC-POTFILES.in
-	$(XGETTEXT) --default-domain=$(PACKAGE) --directory=.. \
+	$(XGETTEXT) -o $(PACKAGE)-tmp.pot --directory=.. \
+	  --default-domain=$(PACKAGE) \
 	  --add-comments --keyword=_ --keyword=N_ \
 	  --join-existing \
 	  --msgid-bugs-address=https://sourceware.org/bugzilla/ \
 	  --files-from=$(srcdir)/BLD-POTFILES.in
 	rm -f $(srcdir)/$(PACKAGE).pot
-	mv $(PACKAGE).po $(srcdir)/$(PACKAGE).pot
+	mv $(PACKAGE)-tmp.pot $(srcdir)/$(PACKAGE).pot
 
 $(srcdir)/cat-id-tbl.c: stamp-cat-id; @:
 $(srcdir)/stamp-cat-id: $(PACKAGE).pot
diff --git a/opcodes/po/Make-in b/opcodes/po/Make-in
index 167b04b7560..6ae60ac2bcd 100644
--- a/opcodes/po/Make-in
+++ b/opcodes/po/Make-in
@@ -87,12 +87,13 @@ all-yes: $(CATALOGS) @MAINT@ $(PACKAGE).pot
 all-no:
 
 $(srcdir)/$(PACKAGE).pot: $(POTFILES)
-	$(XGETTEXT) --default-domain=$(PACKAGE) --directory=$(top_srcdir) \
+	$(XGETTEXT) -o $(PACKAGE)-tmp.pot --directory=$(top_srcdir) \
+	  --default-domain=$(PACKAGE) \
 	  --add-comments --keyword=_ --keyword=N_ \
 	  --msgid-bugs-address=https://sourceware.org/bugzilla/ \
 	  --files-from=$(srcdir)/POTFILES.in
 	rm -f $(srcdir)/$(PACKAGE).pot
-	mv $(PACKAGE).po $(srcdir)/$(PACKAGE).pot
+	mv $(PACKAGE)-tmp.pot $(srcdir)/$(PACKAGE).pot
 
 $(srcdir)/cat-id-tbl.c: stamp-cat-id; @:
 $(srcdir)/stamp-cat-id: $(PACKAGE).pot